<script>
  import Elec from './_design_3_ElL.svelte';
  import Elecr from './_design_3_ElR.svelte';
  import Gasl from './_design_3_GasL.svelte';
  import GasR from './_design_3_GasR.svelte';

  import { onMount } from 'svelte';
  import {json} from 'd3-fetch';

  import {scaleLinear} from 'd3-scale';
  import {extent} from 'd3-array';
  import {max} from 'd3-array';


let datapoints=[];
  onMount(async () => {
    datapoints = await json("/data/hourly_electricity_vs_gas_december.json");
  });
 
	//$: console.log(datapoints)

  //Data for electricity
  let data_electricity = {}
  $: { datapoints.forEach((d) => {
      if(!(d.week in data_electricity)){
        data_electricity[d.week]=[]
      }
      data_electricity[d.week].push(d.total_electrity)
    })
  }
  //$: console.log(data_electricity)

  let data_gas = {}
  $: { datapoints.forEach((d) => {
    if(!(d.week in data_gas)){
      data_gas[d.week]=[]
    }
    data_gas[d.week].push(d.total_gas)
  })
  }
//$: console.log(data_gas)

  // Size and margins
  const width = 500;
  const height = 600;
  const margin = { top: 10, right: 10, bottom: 10, left: 10 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // Scales electricity
  let scaleX=scaleLinear().domain([0, 167]).range([0, 150]);
  let scaleX_left = scaleLinear().domain([0, 167]).range([150, 0]);
  $: scaleY = scaleLinear().domain(extent(datapoints.map((d) => d.total_electrity))).range([0, -50]);

  // Scales gas
  let Xscale = scaleLinear().domain([0, 167]).range([0, 150]);
  let Xscale_left = scaleLinear().domain([0, 167]).range([150, 0]);
  $: Yscale = scaleLinear().domain([0, max(datapoints.map((d) => d.total_gas))]).range([0, 50]);
</script>

<svg {width} {height}>
  <g transform="translate({margin.left}, {margin.top})">
    <!--  -->
    <line x1={innerWidth/2} x2={innerWidth/2} y1="50" y2="550"/> 
    {#each Object.keys(data_electricity) as week_nr, week_idx}
      {#if week_nr == 49 | week_nr == 51}
      <g transform="translate({(innerWidth/2)-150}, {500-week_idx*100}) rotate(15 150 0)">
        <Elec data={data_electricity[week_nr]} scaleX_left = {scaleX_left} scaleY={scaleY} />
      </g>
      {:else}
        <g transform="translate({innerWidth/2}, {500-week_idx*100}) rotate(-15)">
          <Elecr data={data_electricity[week_nr]} scaleX={scaleX} scaleY={scaleY} />
        </g>
      {/if}
    {/each}

    {#each Object.keys(data_gas) as nr_week, idx_week}
        
          {#if nr_week == 49 | nr_week == 51}
            <g transform="translate({(innerWidth/2)-150}, {500-idx_week*100}) rotate(15.5 150 0)">
              <Gasl data={data_gas[nr_week]} Xscale_left={Xscale_left} Yscale={Yscale} />
            </g>
          {:else}
          <g transform="translate({innerWidth/2}, {500-idx_week*100}) rotate(-16.5)">
            <GasR data={data_gas[nr_week]} Xscale={Xscale} Yscale={Yscale} />
          </g>
        {/if}
      {/each}
    <text x={innerWidth/2} y={innerHeight-15} text-anchor="middle">Chicago (December 2014)</text>
  </g>
</svg>

<style>
  svg {
    border: 1px solid black;
    border-radius: 5px;
  }
  line{
    stroke: black;
    width: auto;
    stroke-width: 2;
  }
</style>
